// Star Symphony (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];
unsigned char dir[0x100*8];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
//	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[11];
	int i,fn;
	int trk,sec,size;


	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	disk.SelectDisk(0);
	disk.SetRecordRange(0x01,0x10);
	// [_ǂݍ
	disk.ReadDATA(0x02, 0x01, 0x00, 0x01, 0x01, dir, 0x0800);
	for (fn=0; fn<20; fn++)
	{
		unsigned char *ent = &dir[fn*0x10+0x03ee];
		if (*ent == 0xff) break;	// fBNg̍Ō
		int i;
		int fnp = 0;

		for (i = 0x00; i < 0x08; i++)
		{
			char c = ent[i];				// t@CPo
			if (c==' ') break;
			fname[fnp++] = c;				// t@C\
		}
		if (ent[8] != ' ')			// gqKvȂt
		{
			fname[fnp++] = '.';
		}
		for (i=8; i<11; i++)	// 悤Ɋgqo
		{
			char c=ent[i];
			if (c==' ') break;
			fname[fnp++] = c;
		}
		fname[fnp++] = '\0';		// ̍Ō

		trk  = *(ent+0x0b);			// JngbN
		sec  = *(ent+0x0c)+1;		// JnZN^
		size = *(ent+0x0d)*0x100;	// TCY

		printf("%-11s : %02x %02x %04x\n",fname,trk,sec,size);
		fcut(fname, trk, trk>>1, trk&1, sec, 0x01, 0x0000, size);
	}
	return 0;
}

